function [newpar, Sf, logf_unp, DDlogf_unp, logf, Dlogf, DDlogf, breakid]=NR(Y,Delta,X,initial,SY,indY,n,...
                           rho, r, gammaest, lambda, sigma2, type)

nbeta=size(X,2); ngamma=0;
npar=nbeta+ngamma;
nn=length(SY);

Error=zeros(100,1);
error=1; iter=0; epsilon=0.00001; maxiter=100;
oldbeta=initial(1+(1:nbeta)); 
oldalpha=initial(1);
breakid=0;
newpar=[oldalpha;oldbeta];
while (error>epsilon & iter < maxiter)
    oldpar=[oldalpha;oldbeta];
    [Sf,DSf]=recursive(Y, Delta, X, oldalpha, oldbeta, ...
                            SY, indY, n, rho, r, sigma2, type);
    [logf_unp, DDlogf_unp, logf, Dlogf, DDlogf]=loglik(Y, Delta, X, Sf, oldbeta, ...
                            SY, indY, n, rho, r, lambda, sigma2, type);
    % derivative in parameter transformation
    tempD=[zeros(npar,1), diag(1+zeros(npar,1));  DSf(:, 1:(1+npar))];
    nom=[sum(Sf)-1; Dlogf(1:npar)];
    ind=(1:(npar+nn))';
    denom=[sum(DSf(:,1:(1+npar)));DDlogf(1:npar,ind)*tempD];
    
    if (rcond(denom)<1e-15)
        breakid=0.5;
        break;
    end
    
    newpar=oldpar;
    newpar(1:(1+npar))=oldpar(1:(1+npar))-inv(denom)*nom;
    
    error=sum(abs(newpar-oldpar));     iter=iter+1;
    Error(iter)=error;
    oldalpha=newpar(1); oldbeta=newpar(2:(1+nbeta)); 
end
if sum(isnan(newpar))>0
    breakid=1;
end

