%%%%%%%%%%%%%%%%%%%%%
% LCS data analysis % SNP->smoking->LC survival
%%%%%%%%%%%%%%%%%%%%%

tmp=importdata('data_for_MR7.txt');

Delta1_unsort=tmp.data(:,2);
Y1_unsort=tmp.data(:,1);
n=length(Y1_unsort);
G=tmp.data(:,end); 
Z=sqrt(tmp.data(:, 5)+2);
cov_unsort=[1+zeros(n,1), tmp.data(:, [3:4, 6:11])];

%%% Set up parameters %%%    
z1=1;
z0=0;
sigma2=6;   % 6
type='Cox';

%%% IV analysis %%%
[D, varD, varD2, pval, pval2, time3, est3, low3, upp3, Y1, Delta1, alphas, betas, sig2z]=MendRandom(Y1_unsort, Delta1_unsort, sigma2, cov_unsort, G, Z, z1, z0, type);

[D, D-1.96*sqrt(varD), D+1.96*sqrt(varD), pval]
[D, D-1.96*sqrt(varD2), D+1.96*sqrt(varD2), pval2]


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Naive analysis %%% smoking->survival
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sigma2star=sigma2-(betas(end)/alphas(end))^2*sig2z;
X_orig=[cov_unsort, Z]; 
X_unsort=X_orig;
[Y1,sorti]=sort(Y1_unsort);
Delta1=Delta1_unsort(sorti); 
X=X_unsort(sorti,:);

[betas, cov_betas, HY, Dlogfb, DDlogfb, indY, indYc, Sf1, SY, est3m, low3m, upp3m, time3m]=SemiParaTrans(Y1, Delta1, X, sigma2star, type);
[betas, betas-1.96*sqrt(diag(cov_betas)), betas+1.96*sqrt(diag(cov_betas))]
chistat=(betas./sqrt(diag(cov_betas))).^2;
1-chi2cdf(chistat(end), 1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
