function [G, der, eta, s2star, dereta]=calder(zz, alphas, betas, Sf1, sigma2, sig2z, Xbar, type)
q=size(Xbar, 2);
a0=Xbar*alphas(1:q);
ag=alphas(end);
b0=Xbar*betas(1:q);
bg=betas(end);

nn=length(Sf1);
Lambda_t_all=cumsum(Sf1);
eta=b0-(bg/ag)*a0+(bg/ag)*zz;
s2star=max(0.5, sigma2-sig2z*(bg/ag)^2);
% s2star=4; % Plug-in the true s2star
[G, dG, ddG, d3G]=Gtransform(exp(eta)*Lambda_t_all, s2star, type);
dersub=(bg*a0/ag^2-bg*zz/ag^2)/sqrt(s2star)-eta*bg^2*sig2z/(ag^3*s2star^(3/2)); % Consider the variability of s2star
dereta=[-(bg/ag)*Xbar, dersub, 0, Xbar, -dersub*(ag/bg)];
dertemp2=[(Lambda_t_all*dereta)'; (triu(ones(nn, nn), 0))];
dertemp3=dertemp2.*exp(eta);
der=repmat((exp(-G).*(-dG))', size(dertemp3, 1), 1).*dertemp3;

