% first and second derivative of log-likelihood function

function [Dlogfi, Dlogf, negDDlogf, G]=score(Y, Delta, Xnew, Sf, betahat,...
                                      SY, indY, indYc, n, sigma2, type)

nn=sum(Delta); nbeta=length(betahat); 
nbeta0=size(Xnew,2); %
m=nbeta;
EXbeta=exp(Xnew*betahat); F=indY*Sf; 

logF=zeros(n,1); logF(F>0)=log(F(F>0));
IF=zeros(n,1); IF(F>0)=1./F(F>0);

Fstar=repmat(F(Delta==1)', n, 1).*indY+repmat(F,1,nn).*(1-indY);

temp0=F.*EXbeta;
Dlogtemp0=[repmat(F, 1, nbeta).*Xnew, Fstar];
Dlogtemp1=[Xnew, indY];
[G, dG, d2G, d3G]=Gtransform(temp0, sigma2, type);

tempG=(Delta.*d2G./dG-dG).*EXbeta; 
DtempG=(Delta.*(d3G./dG-d2G.^2./dG.^2)-d2G).*temp0+(Delta.*d2G./dG-dG);
d1=(Delta.*(d3G./dG-d2G.^2./dG.^2)-d2G);
d0=(Delta.*d2G./dG-dG);

Dlogfi=[repmat(Delta, 1, nbeta).*Xnew, repmat(Delta,1,nn).*indYc]...
      +repmat(tempG, 1, m+nn).*Dlogtemp0;
Dlogf=(sum(Dlogfi))';

DDlogf=zeros(m+nn, m+nn);
for i=1:1:n
       indYi=indY(i,:)*1;
       Ull1=d1(i)*EXbeta(i)^2*Fstar(i,:)'*indYi;
       Ull2=d0(i)*EXbeta(i)*(repmat(indYi,nn,1)).*tril(ones(nn,nn));
       Ula1=d1(i)*EXbeta(i)^2*Fstar(i,:)'*Xnew(i,:);    %
       Ula2=d0(i)*EXbeta(i)*F(i)*Fstar(i,:)'*Xnew(i,:); %
       temp2i=DtempG(i)*temp0(i)*Dlogtemp1(i,:)'*Dlogtemp1(i,:);
       temp2i=temp2i.*[ones(m+nn, m), repmat(IF(i), m+nn, nn)];
       temp2i(nbeta+1:end, nbeta+1:end)=Ull1+Ull2;
       temp2i(nbeta+1:end, 1:nbeta0)=Ula1+Ula2;
       DDlogf=DDlogf+temp2i;
end
negDDlogf=-DDlogf;
