function [Y,Delta,G, Z]=simulation_MR(beta0, tau, n, alpha0, sig2_Z0, type, sig2_T0)
G=[-ones(n/2,1)*0; ones(n/2,1)];
% G=randn(n,1)*0.5;
U=randn(n,1)*2; 
Z=alpha0(1)+alpha0(2)*U+G*alpha0(3)+randn(n, 1)*sqrt(sig2_Z0);

X=[ones(n, 1), U, G, Z];
EXbeta=exp(-X*beta0);
if strcmp(type, 'probit')
    T=EXbeta.*exp(randn(n,1)*sqrt(sig2_T0));	
end
if strcmp(type, 'logistic')
    tunif=rand(n,1);
    T=EXbeta.*exp(sqrt(sig2_T0).*log(tunif./(1-tunif))./(pi/sqrt(3)));	
end
if strcmp(type, 'Cox')
    tunif=rand(n,1);
    T=-EXbeta.*log(tunif);	
end
if strcmp(type, 'PO')
    tunif=rand(n,1);
    logit=tunif./(1-tunif);
    T=EXbeta.*logit;	
end

C=quantile(T, 0.4);
Y=min(T,C); Delta=(T<=C);

