function[D, varD, varD2, pval, pval2, time3, est3, low3, upp3, Y1, Delta1, alphas, betas, sig2z]=MendRandom(Y1_unsort, Delta1_unsort, sigma2, cov_unsort, G, Z, z1, z0)

n=length(Delta1_unsort);
q=size(cov_unsort, 2);
nx=n;
nn=sum(Delta1_unsort);
X_orig=[cov_unsort, G, Z]; 

X_unsort=X_orig;
lambda=0; 
[Y1,sorti]=sort(Y1_unsort);
Y1=Y1(1:nx,:); 
Delta1=Delta1_unsort(sorti(1:nx)); 
X=X_unsort(sorti(1:nx),:);

[betas, cov_betas, HY, Dlogfb, DDlogfb, indY, indYc, Sf1, SY]=SemiParaProbit(Y1, Delta1, X(:,[1:q, end-1]), sigma2);
[Dlogfbi, Dlogfb, negDDlogfb ,GG]=score(Y1, Delta1, X(:,1:end-1), Sf1, betas, SY, indY, indYc, n, sigma2);
[alphas, cov_alphas, sig2z, Dlogfai, negDDlogfa]=normeq(X(:,[1:q, end-1]), X(:,end));

[cov_psi, cov_thetas, pa, pt]=covpsi(Dlogfai, Dlogfbi, negDDlogfa, negDDlogfb, nn);
cov_thetas2=blkdiag(cov_alphas, 1, cov_betas);


%%%%%%%%%%%%%%%%%%%%%%%%%
% For survival function %
%%%%%%%%%%%%%%%%%%%%%%%%%

Xcov=X(:,1:size(cov_unsort,2));
Xbar=median(Xcov);

[G1, der1, eta1, s2star1, dereta1]=calder(z1, alphas, betas, Sf1, sigma2, sig2z, Xbar);
[G2, der2, eta2, s2star2, dereta2]=calder(z0, alphas, betas, Sf1, sigma2, sig2z, Xbar);

derdiff=der1-der2;

nn=length(Sf1);
Var_S1=zeros(nn, 1); Var_S2=zeros(nn, 1); Var_Sdiff=zeros(nn, 1);
for k=1:1:nn
    der1k=der1(:,k);
    der2k=der2(:,k);
    derdiffk=derdiff(:,k);
    var_S1=der1k'*cov_psi*der1k;
    var_S2=der2k'*cov_psi*der2k;
    var_Sdiff=derdiffk'*cov_psi*derdiffk;
    Var_S1(k,:)=var_S1;
    Var_S2(k,:)=var_S2;
    Var_Sdiff(k,:)=var_Sdiff;
end
[time1, est1]=stairs(Y1(Delta1==1), exp(-G1));
[time1, low1]=stairs(Y1(Delta1==1), exp(-G1)-1.96*sqrt(Var_S1));
[time1, upp1]=stairs(Y1(Delta1==1), exp(-G1)+1.96*sqrt(Var_S1));
[time2, est2]=stairs(Y1(Delta1==1), exp(-G2));
[time2, low2]=stairs(Y1(Delta1==1), exp(-G2)-1.96*sqrt(Var_S2));
[time2, upp2]=stairs(Y1(Delta1==1), exp(-G2)+1.96*sqrt(Var_S2));
[time3, est3]=stairs(Y1(Delta1==1), exp(-G1)-exp(-G2));
[time3, low3]=stairs(Y1(Delta1==1), exp(-G1)-exp(-G2)-1.96*sqrt(Var_Sdiff));
[time3, upp3]=stairs(Y1(Delta1==1), exp(-G1)-exp(-G2)+1.96*sqrt(Var_Sdiff));

Sdiff=exp(-G1)-exp(-G2);

%%%%%%%%%
% Delta %
%%%%%%%%%

ag=alphas(end);
bg=betas(end);

D=bg/ag;
derD=[-bg/(ag^2), 1/ag];
cov_agbg=cov_thetas([pa-1, pt], [pa-1, pt]);
cov_agbg2=cov_thetas2([pa-1, pt], [pa-1, pt]);
varD=derD*cov_agbg*derD';
varD2=derD*cov_agbg2*derD';
pval=1-chi2cdf(D^2/varD, 1);
pval2=1-chi2cdf(D^2/varD2, 1);
