function[betas, cov_betas, HY, Dlogf1, DDlogf1_unp, indY, indYc, Sf1, SY, est3, upp3, low3, time3]=SemiParaProbit(Y, Delta, X, sigma2)

rho=1.2; r=1; lambda=0;
n1=length(Delta); p=size(X,2);
SY=sort(Y(Delta==1));
nn=sum(Delta==1); 
indY=(repmat(Y,1,nn)>=repmat(SY',n1,1));
indYc=(repmat(Y,1,nn)<=repmat(SY',n1,1));

X_marginal=X(:,1:(end-1));
nbeta0=size(X_marginal, 2)-1; initial1=[1/nn;0;zeros(nbeta0,1);0];
p_margin=size(X_marginal, 2);
[newpar1, Sf1, logf1_unp, DDlogf1_unp, logf1, Dlogf1, DDlogf1, breakid]=NR(Y, Delta, X, initial1, SY, indY, n1, rho, r, 0, lambda, sigma2); 

betas=newpar1(2:end); 
cov_betas=inv(-DDlogf1(1:p,1:p));
inv_DDlogf1=inv(-DDlogf1); 

HY=log(cumsum(Sf1));

Xbar=median(X(:,[1:(end-1)]));
[G1, der1, eta1, dereta1]=calder_marginal(1, betas, Sf1, sigma2, Xbar);
[G2, der2, eta2, dereta2]=calder_marginal(0, betas, Sf1, sigma2, Xbar);

derdiff=der1-der2;

nn=length(Sf1);
Var_S1=zeros(nn, 1); Var_S2=zeros(nn, 1); Var_Sdiff=zeros(nn, 1);
for k=1:1:nn
    der1k=der1(:,k);
    der2k=der2(:,k);
    derdiffk=derdiff(:,k);
    var_S1=der1k'*inv_DDlogf1*der1k;
    var_S2=der2k'*inv_DDlogf1*der2k;
    var_Sdiff=derdiffk'*inv_DDlogf1*derdiffk;
    Var_S1(k,:)=var_S1;
    Var_S2(k,:)=var_S2;
    Var_Sdiff(k,:)=var_Sdiff;
end
[time3, est3]=stairs(Y(Delta==1), exp(-G1)-exp(-G2));
[time3, low3]=stairs(Y(Delta==1), exp(-G1)-exp(-G2)-1.96*sqrt(Var_Sdiff));
[time3, upp3]=stairs(Y(Delta==1), exp(-G1)-exp(-G2)+1.96*sqrt(Var_Sdiff));


