% first and second derivative of log-likelihood function

function [logf_unp, DDlogf_unp, logf, Dlogf, DDlogf]=loglik(Y, Delta, X, Sf, beta,...
                                      SY, indY, n, rho, r, lambda, sigma2)

nn=sum(Delta); nbeta=length(beta); m=nbeta;
EXbeta=exp(X*beta); F=indY*Sf; 
beta_trunc=beta(2:end);

logF=zeros(n,1); logF(F>0)=log(F(F>0));
IF=zeros(n,1); IF(F>0)=1./F(F>0);

temp0=F.*EXbeta;
Dlogtemp0=[X, repmat(IF,1,nn).*indY];       %
[G, dG, d2G, d3G]=Gtransform_norm(temp0, -0, sigma2);
tempG=(Delta.*d2G./dG-dG).*temp0;           %
DtempG=(Delta.*(d3G./dG-d2G.^2./dG.^2)-d2G).*temp0+(Delta.*d2G./dG-dG);

logf_unp=sum(log(Sf(Sf>0)))+Delta'*(X*beta)+Delta(dG>0)'*log(dG(dG>0))...
        -sum(G);
logf=logf_unp-0.5*lambda*beta_trunc'*beta_trunc;            % penalized
Dlogf=[repmat(Delta, 1, nbeta).*X, ...
    repmat(zeros(n, 1),1,nn).*indY]...      %
      +repmat(tempG, 1, m+nn).*Dlogtemp0;   %
ISf=zeros(nn,1); ISf(Sf>0)=1./Sf(Sf>0);
Dlogf=(sum(Dlogf))'+[zeros(m,1); ISf];      %
Dlogf=Dlogf-[0; lambda*beta_trunc; zeros(nn,1)];      % penalized

DDlogf_unp=zeros(m+nn, m+nn);
for i=1:1:n

       DDlogtemp0=[zeros(nbeta,nbeta), zeros(nbeta, nn);
              zeros(nn,nbeta), -IF(i)^2*indY(i,:)'*indY(i,:)];
                            
       temp2i=Delta(i)*DDlogtemp0; 
       temp2i((m+1):end, (m+1):end)=temp2i((m+1):end, (m+1):end)...
                             +Delta(i)*IF(i)^2*indY(i,:)'*indY(i,:);
       DDlogf_unp=DDlogf_unp+temp2i+tempG(i)*DDlogtemp0...
                  +DtempG(i)*temp0(i)*Dlogtemp0(i,:)'*Dlogtemp0(i,:);
end
DDlogf_unp((m+1):end, (m+1):end)=DDlogf_unp((m+1):end, (m+1):end)-diag(ISf.^2);
DDlogf=DDlogf_unp-diag([0, repmat(lambda,1,m-1), zeros(1,nn)]);  % penalized
