% recursive formula for update jump sizes

function [Sf, DSf]=recursive(Y, Delta, X, alpha, beta,...
                                   SY, indY, n, rho, r, sigma2)

nbeta=length(beta); npar=1+nbeta;
nn=length(SY);

Sf=zeros(nn,1); DSf=zeros(nn, npar); 
Sf(nn)=alpha; DSf(nn,:)=[1, zeros(1, npar-1)];
for i=(nn-1):(-1):1
    ind=(Y>=SY(i)).*(Y<SY(i+1)); nind=sum(ind);
    tempX=X(ind==1,:); tempDelta=Delta(ind==1,:);
    tempF=1-repmat(sum(Sf((i+1):nn)), nind, 1);
    DtempF=-repmat(repmat(1,1,nn-i)*DSf((i+1):nn,:), nind,1);
    EXbeta=exp(tempX*beta); 
    dbetaX=[zeros(nind,1), tempX];

    temp0=tempF.*exp(tempX*beta);
    Dlogtemp0=repmat(1./tempF,1, npar).*DtempF+dbetaX;          
    logtemp1=(tempX*beta);  
    temp1=exp(logtemp1);
    Dlogtemp1=dbetaX;
        
    [G, dG, ddG, d3G]=Gtransform_norm(temp0, -0, sigma2);
    tempG=(dG-tempDelta.*ddG./dG);
    DtempG=(ddG-tempDelta.*(d3G./dG-ddG.^2./dG.^2));
   
    ISf=1/Sf(i+1)+tempG'*temp1;
    DISf=-DSf(i+1,:)/Sf(i+1)^2+(DtempG.*temp0.*temp1)'*Dlogtemp0...
                 +(tempG.*temp1)'*Dlogtemp1;
    Sf(i)=1/ISf; DSf(i,:)=-Sf(i)^2*DISf; 
end

